<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>org.springframework.boot</groupId>
        <artifactId>spring-boot-starter-parent</artifactId>
        <version>3.4.1</version>
        <relativePath/> <!-- lookup parent from repository -->
    </parent>

    <groupId>eu.europa.ec.simpl</groupId>
    <artifactId>simpl-parent</artifactId>
    <version>1.1.2</version>
    <packaging>pom</packaging>

    <properties>
        <common.version>1.1.2</common.version>
        <java.version>21</java.version>
        <spring-cloud.version>2024.0.0</spring-cloud.version>
        <mapstruct.version>1.6.3</mapstruct.version>
        <lombok-mapstruct.version>0.2.0</lombok-mapstruct.version>
        <springdoc.version>2.7.0</springdoc.version>
        <bouncycastle.version>1.79</bouncycastle.version>
        <keycloak-admin.version>25.0.5</keycloak-admin.version>
        <jug.version>5.1.0</jug.version>
        <instancio.version>5.2.0</instancio.version>
        <wiremock.version>3.10.0</wiremock.version>
        <spotless.version>2.43.0</spotless.version>
        <spring-shell.version>3.3.3</spring-shell.version>
        <simpl.common.logging.version>1.0.0-SNAPSHOT.39.1a139b97</simpl.common.logging.version>
        <simpl.httpclient.version>1.0.0</simpl.httpclient.version>
        <nimbus.version>9.47</nimbus.version>
        <spring-statemachine-core.version>4.0.0</spring-statemachine-core.version>
        <tika-core.version>3.0.0</tika-core.version>
        <commons-text.version>1.13.0</commons-text.version>
        <shedlock-spring>6.0.2</shedlock-spring>
        <swagger-core.version>2.2.27</swagger-core.version>
        <swagger-parser.version>2.1.24</swagger-parser.version>
    </properties>

    <modules>
        <module>simpl-spring-boot-starter</module>
        <module>simpl-test-lib</module>
        <module>simpl-commons-data</module>
        <module>simpl-api-iaa</module>
    </modules>

    <dependencyManagement>
        <dependencies>
            <dependency>
                <groupId>io.swagger.core.v3</groupId>
                <artifactId>swagger-core</artifactId>
                <version>${swagger-core.version}</version>
            </dependency>
            <dependency>
                <groupId>io.swagger.parser.v3</groupId>
                <artifactId>swagger-parser</artifactId>
                <version>${swagger-parser.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter</artifactId>
                <exclusions>
                    <exclusion>
                        <groupId>org.springframework.boot</groupId>
                        <artifactId>spring-boot-starter-logging</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-spring-boot-starter</artifactId>
                <version>${common.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-commons-data</artifactId>
                <version>${common.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-api-iaa</artifactId>
                <version>${common.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-test-lib</artifactId>
                <version>${common.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>certificate-revocation-common</artifactId>
                <version>${simpl.httpclient.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-http-client</artifactId>
                <version>${simpl.httpclient.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-http-client-feign</artifactId>
                <version>${simpl.httpclient.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.europa.ec.simpl</groupId>
                <artifactId>simpl-http-client-okhttp</artifactId>
                <version>${simpl.httpclient.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.simpl</groupId>
                <artifactId>SIMPL_COMMON_LOGGING</artifactId>
                <version>${simpl.common.logging.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springdoc</groupId>
                <artifactId>springdoc-openapi-starter-webmvc-ui</artifactId>
                <version>${springdoc.version}</version>
            </dependency>
            <dependency>
                <groupId>org.mapstruct</groupId>
                <artifactId>mapstruct</artifactId>
                <version>${mapstruct.version}</version>
            </dependency>
            <dependency>
                <groupId>org.bouncycastle</groupId>
                <artifactId>bcpkix-jdk18on</artifactId>
                <version>${bouncycastle.version}</version>
            </dependency>
            <dependency>
                <groupId>org.keycloak</groupId>
                <artifactId>keycloak-admin-client</artifactId>
                <version>${keycloak-admin.version}</version>
                <exclusions>
                    <exclusion>
                        <groupId>commons-logging</groupId>
                        <artifactId>commons-logging</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            <dependency>
                <groupId>org.springframework.cloud</groupId>
                <artifactId>spring-cloud-dependencies</artifactId>
                <version>${spring-cloud.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.uuid</groupId>
                <artifactId>java-uuid-generator</artifactId>
                <version>${jug.version}</version>
            </dependency>
            <dependency>
                <groupId>org.instancio</groupId>
                <artifactId>instancio-junit</artifactId>
                <version>${instancio.version}</version>
            </dependency>
            <dependency>
                <groupId>org.wiremock</groupId>
                <artifactId>wiremock-jetty12</artifactId>
                <version>${wiremock.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.shell</groupId>
                <artifactId>spring-shell-starter</artifactId>
                <version>${spring-shell.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.shell</groupId>
                <artifactId>spring-shell-dependencies</artifactId>
                <version>${spring-shell.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <dependency>
                <groupId>com.nimbusds</groupId>
                <artifactId>nimbus-jose-jwt</artifactId>
                <version>${nimbus.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.statemachine</groupId>
                <artifactId>spring-statemachine-core</artifactId>
                <version>${spring-statemachine-core.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.tika</groupId>
                <artifactId>tika-core</artifactId>
                <version>${tika-core.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.commons</groupId>
                <artifactId>commons-text</artifactId>
                <version>${commons-text.version}</version>
            </dependency>
            <dependency>
                <groupId>net.javacrumbs.shedlock</groupId>
                <artifactId>shedlock-spring</artifactId>
		<version>${shedlock-spring}</version>
            </dependency>
            <dependency>
                <groupId>net.javacrumbs.shedlock</groupId>
                <artifactId>shedlock-provider-jdbc-template</artifactId>
		<version>${shedlock-spring}</version>
            </dependency>
        </dependencies>
    </dependencyManagement>

    <build>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>com.diffplug.spotless</groupId>
                    <artifactId>spotless-maven-plugin</artifactId>
                    <version>${spotless.version}</version>
                    <executions>
                        <execution>
                            <phase>compile</phase>
                            <goals>
                                <goal>check</goal>
                            </goals>
                        </execution>
                    </executions>
                    <configuration>
                        <java>
                            <palantirJavaFormat/>
                            <importOrder/>
                            <removeUnusedImports/>
                            <formatAnnotations/>
                        </java>
                    </configuration>
                </plugin>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-compiler-plugin</artifactId>
                    <configuration>
                        <annotationProcessorPaths>
                            <path>
                                <groupId>org.mapstruct</groupId>
                                <artifactId>mapstruct-processor</artifactId>
                                <version>${mapstruct.version}</version>
                            </path>
                            <path>
                                <groupId>org.projectlombok</groupId>
                                <artifactId>lombok</artifactId>
                                <version>${lombok.version}</version>
                            </path>
                            <path>
                                <groupId>org.hibernate</groupId>
                                <artifactId>hibernate-jpamodelgen</artifactId>
                                <version>${hibernate.version}</version>
                            </path>
                            <dependency>
                                <groupId>org.projectlombok</groupId>
                                <artifactId>lombok-mapstruct-binding</artifactId>
                                <version>${lombok-mapstruct.version}</version>
                            </dependency>
                        </annotationProcessorPaths>
                        <compilerArgs>
                            <compilerArg>
                                -Amapstruct.defaultComponentModel=spring
                            </compilerArg>
                        </compilerArgs>
                    </configuration>
                </plugin>
                <plugin>
                    <groupId>org.jacoco</groupId>
                    <artifactId>jacoco-maven-plugin</artifactId>
                    <version>0.8.12</version>
                    <executions>
                        <execution>
                            <goals>
                                <goal>prepare-agent</goal>
                            </goals>
                        </execution>
                        <execution>
                            <id>report</id>
                            <phase>test</phase>
                            <goals>
                                <goal>report</goal>
                            </goals>
                        </execution>
                    </executions>
                </plugin>
            </plugins>
        </pluginManagement>

        <plugins>
            <plugin>
                <groupId>com.diffplug.spotless</groupId>
                <artifactId>spotless-maven-plugin</artifactId>
            </plugin>
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
            </plugin>
        </plugins>
    </build>

    <distributionManagement>
        <repository>
            <id>gitlab-maven</id>
            <!--suppress UnresolvedMavenProperty -->
            <url>${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/maven</url>
        </repository>
        <snapshotRepository>
            <id>gitlab-maven</id>
            <!--suppress UnresolvedMavenProperty -->
            <url>${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/maven</url>
        </snapshotRepository>
    </distributionManagement>
</project>
